#ifndef __mouserptparser_h__
#define __mouserptparser_h__



boolean move_Mouse = false;
int joy_factor1 = 1;

int memoX = 0;
int memoY = 0;

class MouseRptParser : public MouseReportParser {
  public:
    // le joyfactor est utilise pour augmenter la sensibilite. Augmentez le joy_factor pour augmenter la sensibilite du joystick.
    // joyfactor de cette class est remplacé par "joyfactor1", mis à jour par la valeur du potentiometre de réglage de sensibilité.
    // Comme la prise en compte de cette valeur est faite dans le setup, il faut faire un reboot pour avoir cette valeur.

    MouseRptParser() : xPos(0), yPos(0), joy_factor(1), pos_limit(512) {};


  private:
    int xPos;       // current X position value
    int yPos;       // current Y position value
    int joy_factor; // factor to scale the joystick value between -512 and +512
    int pos_limit;  // position limit (set to 512 in constructor)
    virtual void OnMouseNotMove(MOUSEINFO *mi);
    virtual void OnMouseMove(MOUSEINFO *mi);


  protected:
    virtual void OnLeftButtonUp(MOUSEINFO *mi);
    virtual void OnLeftButtonDown(MOUSEINFO *mi);
    virtual void OnRightButtonUp(MOUSEINFO *mi);
    virtual void OnRightButtonDown(MOUSEINFO *mi);
    virtual void OnMiddleButtonUp(MOUSEINFO *mi);
    virtual void OnMiddleButtonDown(MOUSEINFO *mi);
};

void MouseRptParser::OnMouseMove(MOUSEINFO *mi) {

  xPos = (mi->dX) * joy_factor1;
  yPos = (mi->dY) * joy_factor1;
  if (xPos < -pos_limit) {
    xPos = -pos_limit;
  }
  else if (xPos > pos_limit) {
    xPos = pos_limit;
  }
  if (yPos < -pos_limit) {
    yPos = -pos_limit;
  }
  else if (yPos > pos_limit) {
    yPos = pos_limit;
  }
  Joystick.X(map(xPos, -pos_limit, pos_limit, 0, 1023));
  Joystick.Y(map(yPos, -pos_limit, pos_limit, 0, 1023));
  if ((xPos != 0) || (yPos != 0)) {
    move_Mouse = true;
  }
};

void MouseRptParser::OnMouseNotMove(MOUSEINFO *mi) {
  if ((xPos != 0) || (yPos != 0))
  {
    xPos = 0;
    yPos = 0;
    Joystick.X(map(xPos, -pos_limit, pos_limit, 0, 1023));
    Joystick.Y(map(yPos, -pos_limit, pos_limit, 0, 1023));
  }
}

void MouseRptParser::OnLeftButtonUp(MOUSEINFO *mi) {
  Joystick.button(5, 0); //arg=numero de bouton, on ou off (0 ou 1)
};

void MouseRptParser::OnLeftButtonDown(MOUSEINFO *mi) {
  Joystick.button(5, 1);
};

void MouseRptParser::OnRightButtonUp(MOUSEINFO *mi) {
  Joystick.button(4, 0);
};

void MouseRptParser::OnRightButtonDown(MOUSEINFO *mi) {
  Joystick.button(4, 1);
};

void MouseRptParser::OnMiddleButtonUp(MOUSEINFO *mi) {
  Joystick.button(3, 0);
};

void MouseRptParser::OnMiddleButtonDown(MOUSEINFO *mi) {
  Joystick.button(3, 1);
};

#endif
